#include <ctype.h>  /* NOLINT */
#include <stdio.h>  /* NOLINT */
#include <stdlib.h> /* NOLINT */
#include <string.h> /* NOLINT */
#include <time.h>   /* NOLINT */

#if defined(_MSC_VER)
#pragma warning(disable : 4996) /* deprecation */
#endif



/* Forward declare test functions. */
int test_incoming_no_op_valid(int, char*[]);
int test_incoming_application_data_no_headers_valid(int, char*[]);
int test_incoming_application_one_compressed_header_pair_valid(int, char*[]);
int test_incoming_application_int32_header_valid(int, char*[]);
int test_outgoing_no_op_valid(int, char*[]);
int test_outgoing_application_data_no_headers_valid(int, char*[]);
int test_outgoing_application_one_compressed_header_pair_valid(int, char*[]);
int test_streaming_decoder_incoming_no_op_valid_single_message(int, char*[]);
int test_streaming_decoder_incoming_application_no_headers(int, char*[]);
int test_streaming_decoder_incoming_application_one_compressed_header_pair_valid(int, char*[]);
int test_streaming_decoder_incoming_application_one_int32_header_pair_valid(int, char*[]);
int test_streaming_decoder_incoming_application_variable_headers_with_empty_length_pair_valid(int, char*[]);
int test_streaming_decoder_incoming_application_one_bool_header_pair_valid(int, char*[]);
int test_streaming_decoder_incoming_multiple_messages(int, char*[]);
int test_channel_handler_single_valid_messages_parse(int, char*[]);
int test_channel_handler_multiple_valid_messages_parse(int, char*[]);
int test_channel_handler_corrupted_crc_fails(int, char*[]);
int test_channel_handler_msg_too_large_fails(int, char*[]);
int test_channel_handler_write_message(int, char*[]);
int test_event_stream_rpc_server_connection_setup_and_teardown(int, char*[]);
int test_event_stream_rpc_server_connection_setup_and_teardown_with_bind_to_zero_port(int, char*[]);
int test_event_stream_rpc_server_connection_connect_flow(int, char*[]);
int test_event_stream_rpc_server_connection_connect_reject_flow(int, char*[]);
int test_event_stream_rpc_server_connection_messages_before_connect_received(int, char*[]);
int test_event_stream_rpc_server_connection_messages_before_connect_ack_sent(int, char*[]);
int test_event_stream_rpc_server_connection_unknown_message_type(int, char*[]);
int test_event_stream_rpc_server_connection_missing_message_type(int, char*[]);
int test_event_stream_rpc_server_connection_missing_message_flags(int, char*[]);
int test_event_stream_rpc_server_connection_continuation_missing_operation(int, char*[]);
int test_event_stream_rpc_server_connection_missing_stream_id(int, char*[]);
int test_event_stream_rpc_server_connection_continuation_messages_flow(int, char*[]);
int test_event_stream_rpc_server_connection_continuation_failure(int, char*[]);
int test_event_stream_rpc_server_connection_stream_id_ahead(int, char*[]);
int test_event_stream_rpc_server_connection_continuation_reused_stream_id_fails(int, char*[]);
int test_event_stream_rpc_server_connection_continuation_max_stream_id_reached(int, char*[]);
int test_event_stream_rpc_client_connection_setup_and_teardown(int, char*[]);
int test_event_stream_rpc_client_connection_connect(int, char*[]);
int test_event_stream_rpc_client_connection_message_before_connect(int, char*[]);
int test_event_stream_rpc_client_connection_protocol_message(int, char*[]);
int test_event_stream_rpc_client_connection_continuation_flow(int, char*[]);
int test_event_stream_rpc_client_connection_unactivated_continuation_fails(int, char*[]);
int test_event_stream_rpc_client_connection_continuation_send_message_on_closed_fails(int, char*[]);
int test_event_stream_rpc_client_connection_continuation_duplicated_activate_fails(int, char*[]);


#ifdef __cplusplus
#  define CM_CAST(TYPE, EXPR) static_cast<TYPE>(EXPR)
#  if __cplusplus >= 201103L
#    define CM_NULL nullptr
#  else
#    define CM_NULL NULL
#  endif
#else
#  define CM_CAST(TYPE, EXPR) (TYPE)(EXPR)
#  define CM_NULL NULL
#endif

/* Create map.  */

typedef int (*MainFuncPointer)(int, char* []); /* NOLINT */
typedef struct /* NOLINT */
{
  const char* name;
  MainFuncPointer func;
} functionMapEntry;

static functionMapEntry cmakeGeneratedFunctionMapEntries[] = {
    {
    "test_incoming_no_op_valid",
    test_incoming_no_op_valid
  },
  {
    "test_incoming_application_data_no_headers_valid",
    test_incoming_application_data_no_headers_valid
  },
  {
    "test_incoming_application_one_compressed_header_pair_valid",
    test_incoming_application_one_compressed_header_pair_valid
  },
  {
    "test_incoming_application_int32_header_valid",
    test_incoming_application_int32_header_valid
  },
  {
    "test_outgoing_no_op_valid",
    test_outgoing_no_op_valid
  },
  {
    "test_outgoing_application_data_no_headers_valid",
    test_outgoing_application_data_no_headers_valid
  },
  {
    "test_outgoing_application_one_compressed_header_pair_valid",
    test_outgoing_application_one_compressed_header_pair_valid
  },
  {
    "test_streaming_decoder_incoming_no_op_valid_single_message",
    test_streaming_decoder_incoming_no_op_valid_single_message
  },
  {
    "test_streaming_decoder_incoming_application_no_headers",
    test_streaming_decoder_incoming_application_no_headers
  },
  {
    "test_streaming_decoder_incoming_application_one_compressed_header_pair_valid",
    test_streaming_decoder_incoming_application_one_compressed_header_pair_valid
  },
  {
    "test_streaming_decoder_incoming_application_one_int32_header_pair_valid",
    test_streaming_decoder_incoming_application_one_int32_header_pair_valid
  },
  {
    "test_streaming_decoder_incoming_application_variable_headers_with_empty_length_pair_valid",
    test_streaming_decoder_incoming_application_variable_headers_with_empty_length_pair_valid
  },
  {
    "test_streaming_decoder_incoming_application_one_bool_header_pair_valid",
    test_streaming_decoder_incoming_application_one_bool_header_pair_valid
  },
  {
    "test_streaming_decoder_incoming_multiple_messages",
    test_streaming_decoder_incoming_multiple_messages
  },
  {
    "test_channel_handler_single_valid_messages_parse",
    test_channel_handler_single_valid_messages_parse
  },
  {
    "test_channel_handler_multiple_valid_messages_parse",
    test_channel_handler_multiple_valid_messages_parse
  },
  {
    "test_channel_handler_corrupted_crc_fails",
    test_channel_handler_corrupted_crc_fails
  },
  {
    "test_channel_handler_msg_too_large_fails",
    test_channel_handler_msg_too_large_fails
  },
  {
    "test_channel_handler_write_message",
    test_channel_handler_write_message
  },
  {
    "test_event_stream_rpc_server_connection_setup_and_teardown",
    test_event_stream_rpc_server_connection_setup_and_teardown
  },
  {
    "test_event_stream_rpc_server_connection_setup_and_teardown_with_bind_to_zero_port",
    test_event_stream_rpc_server_connection_setup_and_teardown_with_bind_to_zero_port
  },
  {
    "test_event_stream_rpc_server_connection_connect_flow",
    test_event_stream_rpc_server_connection_connect_flow
  },
  {
    "test_event_stream_rpc_server_connection_connect_reject_flow",
    test_event_stream_rpc_server_connection_connect_reject_flow
  },
  {
    "test_event_stream_rpc_server_connection_messages_before_connect_received",
    test_event_stream_rpc_server_connection_messages_before_connect_received
  },
  {
    "test_event_stream_rpc_server_connection_messages_before_connect_ack_sent",
    test_event_stream_rpc_server_connection_messages_before_connect_ack_sent
  },
  {
    "test_event_stream_rpc_server_connection_unknown_message_type",
    test_event_stream_rpc_server_connection_unknown_message_type
  },
  {
    "test_event_stream_rpc_server_connection_missing_message_type",
    test_event_stream_rpc_server_connection_missing_message_type
  },
  {
    "test_event_stream_rpc_server_connection_missing_message_flags",
    test_event_stream_rpc_server_connection_missing_message_flags
  },
  {
    "test_event_stream_rpc_server_connection_continuation_missing_operation",
    test_event_stream_rpc_server_connection_continuation_missing_operation
  },
  {
    "test_event_stream_rpc_server_connection_missing_stream_id",
    test_event_stream_rpc_server_connection_missing_stream_id
  },
  {
    "test_event_stream_rpc_server_connection_continuation_messages_flow",
    test_event_stream_rpc_server_connection_continuation_messages_flow
  },
  {
    "test_event_stream_rpc_server_connection_continuation_failure",
    test_event_stream_rpc_server_connection_continuation_failure
  },
  {
    "test_event_stream_rpc_server_connection_stream_id_ahead",
    test_event_stream_rpc_server_connection_stream_id_ahead
  },
  {
    "test_event_stream_rpc_server_connection_continuation_reused_stream_id_fails",
    test_event_stream_rpc_server_connection_continuation_reused_stream_id_fails
  },
  {
    "test_event_stream_rpc_server_connection_continuation_max_stream_id_reached",
    test_event_stream_rpc_server_connection_continuation_max_stream_id_reached
  },
  {
    "test_event_stream_rpc_client_connection_setup_and_teardown",
    test_event_stream_rpc_client_connection_setup_and_teardown
  },
  {
    "test_event_stream_rpc_client_connection_connect",
    test_event_stream_rpc_client_connection_connect
  },
  {
    "test_event_stream_rpc_client_connection_message_before_connect",
    test_event_stream_rpc_client_connection_message_before_connect
  },
  {
    "test_event_stream_rpc_client_connection_protocol_message",
    test_event_stream_rpc_client_connection_protocol_message
  },
  {
    "test_event_stream_rpc_client_connection_continuation_flow",
    test_event_stream_rpc_client_connection_continuation_flow
  },
  {
    "test_event_stream_rpc_client_connection_unactivated_continuation_fails",
    test_event_stream_rpc_client_connection_unactivated_continuation_fails
  },
  {
    "test_event_stream_rpc_client_connection_continuation_send_message_on_closed_fails",
    test_event_stream_rpc_client_connection_continuation_send_message_on_closed_fails
  },
  {
    "test_event_stream_rpc_client_connection_continuation_duplicated_activate_fails",
    test_event_stream_rpc_client_connection_continuation_duplicated_activate_fails
  },

  { CM_NULL, CM_NULL } /* NOLINT */
};

static const int NumTests = CM_CAST(int,
  sizeof(cmakeGeneratedFunctionMapEntries) / sizeof(functionMapEntry)) - 1;

/* Allocate and create a lowercased copy of string
   (note that it has to be free'd manually) */
static char* lowercase(const char* string)
{
  char *new_string;
  char *p;
  size_t stringSize;

  stringSize = CM_CAST(size_t, strlen(string) + 1);
  new_string = CM_CAST(char*, malloc(sizeof(char) * stringSize));

  if (new_string == CM_NULL) { /* NOLINT */
    return CM_NULL;            /* NOLINT */
  }
  strcpy(new_string, string);  /* NOLINT */
  for (p = new_string; *p != 0; ++p) {
    *p = CM_CAST(char, tolower(*p));
  }
  return new_string;
}

int isTestSkipped(const char *name, int n_skipped_tests, char *skipped_tests[]) {
  int i;
  for (i = 0; i < n_skipped_tests; i++) {
    if (strcmp(name, skipped_tests[i]) == 0) {
      return 1;
    }
  }

  return 0;
}

int main(int ac, char* av[])
{
  int i;
  int testNum = 0;
  int partial_match;
  int run_all;
  char *arg;
  int testToRun = -1;

  

  /* If no test name was given */
  /* process command line with user function.  */
  if (ac < 2) {
    /* Ask for a test.  */
    printf("Available tests:\n");
    for (i = 0; i < NumTests; ++i) {
      printf("%3d. %s\n", i, cmakeGeneratedFunctionMapEntries[i].name);
    }
    printf("To run a test, enter the test number: ");
    fflush(stdout);
    if (scanf("%d", &testNum) != 1) {
      printf("Couldn't parse that input as a number\n");
      return -1;
    }
    if (testNum >= NumTests) {
      printf("%3d is an invalid test number.\n", testNum);
      return -1;
    }
    testToRun = testNum;
    ac--;
    av++;
  }
  partial_match = 0;
  run_all = 0;
  arg = CM_NULL; /* NOLINT */
  /* If partial match or running all tests are requested.  */
  if (testToRun == -1 && ac > 1) {
    partial_match = (strcmp(av[1], "-R") == 0) ? 1 : 0;
    run_all = (strcmp(av[1], "-A") == 0) ? 1 : 0;
  }
  if (partial_match != 0 && ac < 3) {
    printf("-R needs an additional parameter.\n");
    return -1;
  }
  if (run_all == 1) {
    clock_t t;
    int status = 0;
    const char* status_message = CM_NULL;
    printf("TAP version 13\n");
    printf("1..%d\n", NumTests);
    for (i = 0; i < NumTests; ++i) {
      const char *name = cmakeGeneratedFunctionMapEntries[i].name;
      if (ac > 2) {
        if (isTestSkipped(name, ac - 2, av + 2) == 1) {
          printf("ok %d %s # SKIP\n", i + 1, name);
          continue;
        }
      }
      t = clock();
      status = (*cmakeGeneratedFunctionMapEntries[i].func)(ac, av);
      t = clock() - t;
      status_message = (status == -1) ? "not ok" : "ok";
      {
        double time_taken = CM_CAST(double, t) / CLOCKS_PER_SEC;
        printf("%s %d %s # %f\n", status_message, i + 1, name, time_taken);
      }
    }
    printf("All tests finished.\n");

    return 0;
  }

  if (testToRun == -1) {
    arg = lowercase(av[1 + partial_match]);
  }
  for (i = 0; i < NumTests && testToRun == -1; ++i) {
    char *test_name = lowercase(cmakeGeneratedFunctionMapEntries[i].name);
    if (partial_match != 0 && strstr(test_name, arg) != CM_NULL) { /* NOLINT */
      testToRun = i;
      ac -= 2;
      av += 2;
    } else if (partial_match == 0 && strcmp(test_name, arg) == 0) {
      testToRun = i;
      ac--;
      av++;
    }
    free(test_name);
  }
  free(arg);
  if (testToRun != -1) {
    int result;

    if (testToRun < 0 || testToRun >= NumTests) {
      printf("testToRun was modified by TestDriver code to an invalid value: "
             "%3d.\n",
             testNum);
      return -1;
    }
    result = (*cmakeGeneratedFunctionMapEntries[testToRun].func)(ac, av);

    return result;
  }

  /* Nothing was run, display the test names.  */
  printf("Available tests:\n");
  for (i = 0; i < NumTests; ++i) {
    printf("%3d. %s\n", i, cmakeGeneratedFunctionMapEntries[i].name);
  }
  printf("Failed: %s is an invalid test name.\n", av[1]);

  return -1;
}
